#!/bin/bash

blanktype=$1
cdwriter=$2

if [ ! -b "$cdwriter" ]; then
	echo "usage: $0 all|fast cdwriter"
	echo "example: $0 fast /dev/sr0"
	exit
fi


udi=`hal-find-by-property --key block.device --string $cdwriter | grep volume`
mediatype=`hal-get-property --udi $udi --key volume.disc.type`

if [ `echo $mediatype | cut -c1-2` == "cd" ]
then cdrecord gracetime=3 blank=$blanktype dev=$cdwriter
else if [ `echo $mediatype | cut -c1-3` == "dvd" ]
	then dvd+rw-format -force $cdwriter 
		if [ "$blanktype" == "all" ]
		then growisofs -Z $cdwriter=/dev/zero
		fi
	fi
fi
