#!/bin/bash

cdreader=$1
cdwriter=$2

if [ ! -b "$cdwriter" ] || [ ! -b "$cdreader" ] || [ $cdwriter == $cdreader ]; then
	echo "usage: $0 cdreader cdwriter"
	echo "example: $0 /dev/sr0 /dev/sr1"
	exit
fi


tempdir="/tmp/simplebur$$"

mkdir $tempdir
cd $tempdir

cdda2wav dev=$cdreader -vtoc -L1 -info-only
trackslengths=""
for infofile in *.inf; do 
	tracklength=`sed -n /Tracklength/p $infofile | sed 's/\t//' | cut -f2 -d= | cut -f1 -d,`
	let tracklength=tracklength/512
	trackslengths="$trackslengths$tracklength "
done

cdda2wav dev=$cdreader -no-infofile -B -Oraw - 2>/dev/null | cdrecord -v gracetime=3 dev=$cdwriter -dao -audio -useinfo -text *.inf | simpleburn-gauges $trackslengths

cd - >/dev/null
rm -rf $tempdir
