#!/bin/bash

cdreader=$1
shift; directory="$*"

if [ ! -d "$directory" ] || [ ! -b "$cdreader" ]; then
	echo "usage: $0 cdreader directory"
	echo "example: $0 /dev/sr0 /home/me/audio"
	exit
fi


trackslenghts=`cdda2wav -N -J -v toc dev=$cdreader 2>&1 | sed -n '/(/p' | sed 's/[0-9]*\.( //g' | sed 's/\.[0-9]*)//g' | sed 's/,//g'`
audiosizes=""
for tracklength in $trackslenghts; do
	minutes=`echo $tracklength | cut -f1 -d: | sed 's/^0*//'`
	seconds=`echo $tracklength | cut -f2 -d: | sed 's/^0*//'`
	let seconds=(minutes*60)+seconds
	audiosizes="$audiosizes$seconds "
done

cd "$directory"

cdda2wav -L1 dev=$cdreader -B "$directory"/audio 2>&1 | simpleburn-gauges CDDA $audiosizes

#renaming
if [ -f "$directory"/audio.cddb ]
then ls "$directory"/*.inf | while read trackinfofile; do 
		tracknumber=` echo $trackinfofile | sed 's/^.*_\([0-9]*\).inf$/\1/'`
		albumtitle=`cat $trackinfofile | grep "Albumtitle" | sed 's/.*=\t//' | sed s@/@-@g`
		tracktitle=`cat $trackinfofile | grep "Tracktitle" | sed 's/.*=\t//' | sed s@/@-@g`
		mv "$directory"/audio_$tracknumber.wav "$directory"/"$albumtitle"-$tracknumber-"$tracktitle".wav
		mv "$directory"/audio_$tracknumber.inf "$directory"/"$albumtitle"-$tracknumber-"$tracktitle".inf
	done
	rm -f "$directory"/audio.{cdindex,cddb}
fi

cd - >/dev/null
