gchar *cdwriterswidgets[] = { "burnimagecdwriter", "burndirectorycdwriter", "blankcdwriter", "copycdwriter", NULL };
gchar *cdreaderswidgets[] = { "extractimagecdreader", "extractaudiocdreader", "infocdreader", "copycdreader", NULL };
gchar *actionwidgets[] = { "extractimage", "burnimage", "extractaudio", "burnaudiodirectory", "burndatadirectory", "fastblanking", "completeblanking", "detectmedia", "copymedia", "ejectmedia", NULL };


void disableactions() {
	gint i;
	gint actionwidgetscount = g_strv_length( actionwidgets );
	
	for ( i=0; i<actionwidgetscount; i++ )
		gtk_widget_set_sensitive( (GtkWidget *) gtk_builder_get_object( xml, actionwidgets[i] ), FALSE );
}


void enableactions() {
	gint i;
	gint actionwidgetscount = g_strv_length( actionwidgets );
	
	for ( i=0; i<actionwidgetscount; i++ )
		gtk_widget_set_sensitive( (GtkWidget *) gtk_builder_get_object( xml, actionwidgets[i] ), TRUE );
}


void displayerror( gchar *message ) {
	GtkLabel *logwidget;
	
	logwidget = (GtkLabel*) gtk_builder_get_object( xml, "log" );
	gtk_label_set_text( logwidget, message );
}


void displayinfo( gchar *message ) {
	displayerror( message );
}


void cdreaderchangehandler( GtkWidget *widget, gpointer user_data ) {
	gint j;
	gint cdreaderswidgetscount = g_strv_length( cdreaderswidgets );
	
	for ( j=0; j<cdreaderswidgetscount; j++ ) {
		gtk_combo_box_set_active( (GtkComboBox*) gtk_builder_get_object( xml, cdreaderswidgets[j] ), gtk_combo_box_get_active( (GtkComboBox*) widget ) );
	}
}


void cdwriterchangehandler( GtkWidget *widget, gpointer user_data ) {
	gint j;
	gint cdwriterswidgetscount = g_strv_length( cdwriterswidgets );
	
	for ( j=0; j<cdwriterswidgetscount; j++ ) {
		gtk_combo_box_set_active( (GtkComboBox*) gtk_builder_get_object( xml, cdwriterswidgets[j] ), gtk_combo_box_get_active( (GtkComboBox*) widget ) );
	}
}


void initcddevices() {
	GtkWidget *cdwriterwidget, *cdreaderwidget;
	gchar **cdwriters, **cdreaders;
	gint cdwriterswidgetscount = g_strv_length( cdwriterswidgets );
	gint cdreaderswidgetscount = g_strv_length( cdreaderswidgets );
	gint i, j;

	listcdwriters( &cdwriters );
	if ( cdwriters[0] == NULL ) {
		displayerror( gettext( "Error : no CD / DVD burner detected." ) );
		disableactions();
	} else {
		for ( j=0; j<cdwriterswidgetscount; j++ ) {
			cdwriterwidget = (GtkWidget *) gtk_builder_get_object( xml, cdwriterswidgets[j] );
			for ( i=0; cdwriters[i] != NULL; i++ )
				gtk_combo_box_append_text( (GtkComboBox*) cdwriterwidget, cdwriters[i] );
			gtk_combo_box_remove_text( (GtkComboBox*) cdwriterwidget, 0 ); /* hack */
			gtk_combo_box_set_active( (GtkComboBox*) cdwriterwidget, 0 );
		}
		for ( i=0; cdwriters[i] != NULL; i++ )
			g_free( cdwriters[i] );
	}
	g_free( cdwriters );
	
	listcdreaders( &cdreaders );
	if ( cdreaders[0] != NULL ) {
		for ( j=0; j<cdreaderswidgetscount; j++ ) {
			cdreaderwidget = (GtkWidget *) gtk_builder_get_object( xml, cdreaderswidgets[j] );
			for ( i=0; cdreaders[i] != NULL; i++ )
				gtk_combo_box_append_text( (GtkComboBox*) cdreaderwidget, cdreaders[i] );
			gtk_combo_box_remove_text( (GtkComboBox*) cdreaderwidget, 0 ); /* hack */
			gtk_combo_box_set_active( (GtkComboBox*) cdreaderwidget, 0 );
		}
		for ( i=0; cdreaders[i] != NULL; i++ )
			g_free( cdreaders[i] );
	}
	g_free( cdreaders );
}


void addisofilter() {
	GtkFileFilter *filter;
	GtkFileChooser *filechooserwidget;
	
	filter = gtk_file_filter_new();
	gtk_file_filter_add_pattern( filter, "*.iso" );
	gtk_file_filter_set_name( filter, "*.iso" );
	filechooserwidget = (GtkFileChooser *) gtk_builder_get_object( xml, "burnimagefile" );
	gtk_file_chooser_add_filter( filechooserwidget, filter );
}
