#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define FALSE 0
#define TRUE 1
#define BOOLEAN unsigned short


void cdrecordgauge ( int trackscount, int trackslengths[] ) {
	int i, totalsize, totalwrittensize, percentpertrack, previousprogress;
	BOOLEAN starting, readwrittensize, readtracksize, endoftrack;
	char line[80];
	char writtensize[4];
	char tracksize[4];
	int length;
	int percent, lastpercent;
	int c;
	char echocommand[9];
	
	
	totalsize = 0;
	for (i=0; i<trackscount; i++) {
		totalsize += trackslengths[i];
	}
	
	totalwrittensize = 0;
	lastpercent = -1;
	for (i=0; i<trackscount; i++) {
		percentpertrack = (trackslengths[i] * 100) / totalsize;
		starting = FALSE;
		while (! starting) {
			fgets (line, 80, stdin);
			line[18] = '\0';
			if (strncmp (line, "Starting new track", 18) == 0)
				starting = TRUE;
		}
		
		previousprogress = (totalwrittensize * 100) / totalsize;
		writtensize[0] = '\0';
		tracksize[0] = '\0';
		readwrittensize = FALSE;
		readtracksize = FALSE;
		endoftrack = FALSE;
		
		c = fgetc(stdin);
		while ((c != EOF) && (! endoftrack)) {
			switch (c) {
			case 58:
				readwrittensize = TRUE; //':' Track %02d:
				break;
			case 111:
				if (readwrittensize) { //'o' of
					readwrittensize = FALSE;
					readtracksize = TRUE;
				}
				break;
			case 77:
				if (readtracksize) { //'M' MB
					readtracksize = FALSE;
					percent = ((atoi(writtensize) * percentpertrack) / atoi(tracksize)) + previousprogress;
					if ( percent !=  lastpercent ) {
						sprintf (echocommand, "echo %d", percent);
						system (echocommand);
						lastpercent = percent;
					}
					writtensize[0] = '\0';
					tracksize[0] = '\0';
				}
				break;
			case 47:
				endoftrack = TRUE; //'/'
				break;
			default:
				if (( c >= 48) && (c <= 57)) { //[0-9]
					if (readwrittensize) {
						length = strlen (writtensize);
						writtensize[length] = c;
						writtensize[length+1] = '\0';
					} else {
						if (readtracksize) {
							length = strlen (tracksize);
							tracksize[length] = c;
							tracksize[length+1] = '\0';
						}
					}
				}
			}
			c = fgetc(stdin);
		}
		totalwrittensize += trackslengths[i];
	}
	
	system ("echo 100");
	while (getc (stdin) != EOF);
}


void cdda2wavgauge ( int trackscount, int trackslengths[] ) {
	int i, totalsize, totalwrittensize, percent, percentpertrack, lastpercent, previousprogress;
	BOOLEAN starting, endoftrack;
	char line[80];
	int length;
	char trackpercent[4];
	int c;
	char echocommand[9];
	
	totalsize = 0;
	for (i=0; i<trackscount; i++) {
		totalsize += trackslengths[i];
	}
	
	starting = FALSE;
	while (! starting) {
		fgets (line, 80, stdin);
		line[13] = '\0';
		if (strncmp (line, "percent_done:", 13) == 0)
			starting = TRUE;
	}
	
	totalwrittensize = 0;
	lastpercent = -1;
	for (i=0; i<trackscount; i++) {
		percentpertrack = (trackslengths[i] * 100) / totalsize;
		previousprogress = (totalwrittensize * 100) / totalsize;
		endoftrack = FALSE;
		trackpercent[0] = '\0';
		c = fgetc(stdin);
		while ((c != EOF) && (! endoftrack)) {
			switch (c) {
			case 37: //'%'
				percent = (atoi (trackpercent) * percentpertrack) / 100 + previousprogress;
				if ( percent !=  lastpercent ) {
					sprintf (echocommand, "echo %d", percent);
					system (echocommand);
					lastpercent = percent;
				}
				trackpercent[0] = '\0';
				break;
			case 32:
				break;
			case 13:
				break;
			default:
				if (( c >= 48) && (c <= 57)) { //[0-9]
					length = strlen (trackpercent);
					trackpercent[length] = c;
					trackpercent[length+1] = '\0';
				} else
					endoftrack = TRUE;
			}
			c = fgetc(stdin);
		}
		totalwrittensize += trackslengths[i];
		fgets (line, 80, stdin);
	}
	
	system ("echo 100");
	while (getc (stdin) != EOF);
}


int main (int argc, char *argv[]) {
	int i;
	int *args;
	
	args = (int *) malloc (argc * sizeof (int));
	
	if (strncmp (argv[1], "CDDA", 4) == 0) {
		for (i=2; i<argc; i++)
			args[i-2] = atoi (argv[i]);
		cdda2wavgauge (argc - 2, args);
	} else {
		for (i=1; i<argc; i++)
			args[i-1] = atoi (argv[i]);
		cdrecordgauge (argc - 1, args);
	}
	free (args);
}
