#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <libintl.h>
#include <locale.h>
#include <glob.h>
#include <signal.h>
#include <hal/libhal.h>

#include "config.h"

GtkBuilder *xml;
#include "common-detection.c"
#include "common-interface.c"
#include "common-filesize.c"
#include "common-checks.c"
#include "common-launch.c"
#include "callbacks-blank.c"
#include "callbacks-burn.c"
#include "callbacks-extract.c"
#include "callbacks-copy.c"
#include "callbacks-misc.c"


int main( int argc, char *argv[] ) {
	GtkWidget *mainwindow;
	GtkAboutDialog *aboutdialog;
	
	setlocale( LC_ALL, "" );
	bindtextdomain( PROJECT_NAME, LOCALE_DIR );
	textdomain( PROJECT_NAME );
	
	gtk_init( &argc, &argv );
	xml = gtk_builder_new();
	gtk_builder_add_from_file( xml, UI_FILE, NULL );

	initcddevices();
	addisofilter(); //to the burnimagecdwriterwidget; can't be done in Glade
	gtk_progress_bar_set_text( (GtkProgressBar*) gtk_builder_get_object( xml, "progressbar" ), "" ); //to hide default 0% progress
	gtk_builder_connect_signals( xml, NULL );
	
	mainwindow = (GtkWidget *) gtk_builder_get_object( xml, "mainwindow" );
	aboutdialog = (GtkAboutDialog *) gtk_builder_get_object( xml, "aboutdialog" );
	gtk_about_dialog_set_version( aboutdialog, PROJECT_VERSION );
	gtk_widget_show( mainwindow );
	gtk_main();
}
